var Enemy = new Object;
var Rank = 1;
var Score = new Object;
Score["fairy"] = 1000;
Score["soul"] = 1000;
Score["dot"] = 50;

function _ (id)
{ return document.getElementById (id); }

function remove_children (parent)
{
  var child;

  while (child = parent.firstChild)
    parent.removeChild (child);
}

// ̈ʂ؂̂
function floor (n)
{
  return Math.floor (n / 10) * 10;
}

// ̈ʂJグ
function ceil (n)        
{
  var rest = n % 10;
  return rest != 0 ? n + (10 - rest) : n;
}

function set_Enemy (rank)
{
  function aux (head, tail, hit_mul)
  {
    var r = new Object;

    r["head"] = head;           // Γ_̎
    r["tail"] = tail;
    r["hit *"] = hit_mul;       // Ԗڈȍ~ tail + qbg * 

    return r;
  }

  // d
  Enemy["fairy"] = aux (// rank5->630->40, 10->1140->50, 15->1650->60
                        ceil (20 + 2 * rank),
                        // rank12->1320->30, 15->1630->40?@
                        10 + 10 * Math.floor ((Math.max (rank, 10) - 7) / 3),
                        // rank1060, 1570?@
                        30 + 3 * rank);
  // 
  Enemy["soul"] = aux (2000 + 200 * rank,
                       1000 + 100 * rank,
                       200 + 20 * rank);
  // e
  Enemy["dot"] = aux (0, 0, 10 + rank); // 񂾂ǁc
}

function rank_onkeyup ()
{
  function f (object, element, text)
  {
    var node = document.createElement (element);
    var text_node = document.createTextNode (text);

    node.appendChild (text_node);
    object.appendChild (node);
  }

  var rank = parseInt (_("rank").value);

  if (isNaN (rank))
    return;

  Rank = rank;
  set_Enemy (Rank);

  remove_children (_("tbody-spellpoint"));
  for (var key in Enemy)
    {
      var tr = document.createElement ("tr");

      switch (key)
        {
        case "fairy":
          f (tr, "td", "d");
          break;

        case "soul":
          f (tr, "td", "");
          break;

        default:
          f (tr, "td", "e");
          break;
        }
      f (tr, "td", Score[key]);
      f (tr, "td", Enemy[key]["head"]);
      f (tr, "td", Enemy[key]["tail"]);
      f (tr, "td", Enemy[key]["hit *"]);
      f (tr, "td", key == "dot" ? "No" : "Yes");

      _("tbody-spellpoint").appendChild (tr);
    }
}

function difficulty_onclick ()
{
  // EasyNormalꏏ݂Ȃ
  if (_("difficulty-easy").checked
      || _("difficulty-normal").checked)
    _("rank").value = 1;
  else if (_("difficulty-hard").checked)
    _("rank").value = 6;
  else if (_("difficulty-lunatic").checked)
    _("rank").value = 8;
  else                          // Extra
    _("rank").value = 18;

  rank_onkeyup ();
}
function diff ()
{ difficulty_onclick (); }

function parse (s)
{
  var r = new Array;
  var re = new RegExp ("(?:(d?|f)|(|s)|(e|d))(\\d*)|(/)", "ig");
  var end = false;              // ItO
  var callback =
    function (_, fairy, soul, dot, n, _end)
    {
      if (end)
        return;
      if (_end)
        {
          end = true;
          return;
        }

      var enemy = new String;
      var times = n ? parseInt (n) : 1; // rɒǉ

      if (fairy)
        enemy = "fairy";
      else if (soul)
        enemy = "soul";
      else
        enemy = "dot";
      for (var i = 0; i < times; ++i)
        r.push (enemy);
    }

  s = s.replace (/\s|@/g, ""); // 󔒂폜
  s.replace (re, callback);

  return r;
}

function calc ()
{

  var arr = parse (_("expression").innerText); // iHj
  // alert (arr);
  if (arr.length == 0)
    return;

  var spellpoint = Enemy[arr[0]]["head"];
  var score = Score[arr[0]];
  var hit = arr[i] != "dot" ? 1 : 0; // qbg

  for (var i = 1; i < arr.length; ++i)
    {
      var e = Enemy[arr[i]];

      if (arr[i] == "dot")
        spellpoint += ceil (e["hit *"] * hit); // ł̂H@ʂ͍񂾂
      else
        spellpoint += e["tail"] + floor (e["hit *"] * hit);
      if (arr[i] != "dot")      // eȂqbgɑ
        ++hit;
      score += Score[arr[i]];
    }
  score += spellpoint;          // R{̌pԂ؂ꂽZ

  _("score").innerText = score;
  _("spellpoint").innerText = spellpoint;
}
